//============================================================================
// Name        : ParserMain.cpp
// Author      : Alexander Konrad
// Version     :
// Copyright   : Copyright 2019
//============================================================================


#include <list>
#include <iostream>
#include "Circuit.h"
#include "ParseError.h"
#include "Monom2.h"
#include "Polynom.h"
#include "Verifizierer.h"
#include "math.h"

using namespace std;
using namespace vp;

int main(int argc, char* argv[]) {
	if (argc != 3) {
		cout << " Wrong number of arguments. Usage: " << argv[0] << " [Verilog Circuit File] " << " [Signature Description File] " << endl; 
		return 1;   
	}

	// Usage examples: ./ExampleMain Schaltungen/RCA_Signed_Wide_4bit.v Adder_signature.txt to verify signed Ripple-Carry-Adder example.
	// ./ExampleMain Schaltungen/16bit_SPARC_mult.v Multiplier_signature.txt to verify unsigned multiplier example.


	// Create verifier object with parsed circuit and signature file.
	Verifizierer test1(argv[1], argv[2]);
	
	// Start verification process.
	test1.startVerification(argv[2]);
	
	if (test1.poly.size() == 0) cout << "Result after backward rewriting is empty polynomial. Verification successfull." << endl; 
	
	return 0;
}
