/*
 * MyList.h
 *
 *  Created on: 30.10.2018
 *      Author: Alexander Konrad
 */

#include <string>

#ifndef MYLIST_H_
#define MYLIST_H_

class Monom2;

class MyList {

friend class Monom2;
friend class Polynom;

private: 
	
	// Class used for ListElements
	class ListElement {
    		public:
        	// Konstruktor
        	ListElement(Monom2* data)
        	{
        	    this->data = data;
        	    next = NULL;
        	    prev = NULL;
        	}
 
        	// Zeiger auf den Nachfolger
        	ListElement* next;
        	ListElement* prev; 
 
        	// Das sind die Daten die wir verwalten wollen ( Datenbereich)
        	Monom2* data;
    	};
    	
    	// Member of List class.
	ListElement* head;
	ListElement* tail; 
	int size;
	
public:	
	// Iterator for the list.
	class Iterator
	{
	protected:
	    // Pointer to current list element.
	    ListElement* iter;
 
	public:
	    // der Listeklasse erlauben auf protected-Elemente zuzugreifen
	    friend MyList;
 
	    // Konstruktor
	    Iterator(void) : iter(NULL) {}
	    Iterator(ListElement* le) : iter(le) {}
	     
	    // Zuweisungsoperator
	    void operator=(ListElement* le)
	    {
	        iter = le;
	    }
 
	    // Vergleichsoperator
	    bool operator!=(ListElement* le)
	    {
	        if(NULL != iter && iter!=le) return true;
	        else return false;
	    }
	    
	    // Vergleichsoperator
	    bool operator==(ListElement* le)
	    {
		if(NULL != iter && iter==le) return true;
		else return false;
            }
 
	    // Inkrementierungsoperator 
	    void operator++ (int)
	    {
	        if(iter != NULL)
	            iter = iter->next;
	    }
	    
	    void operator-- (int)
	    {
		if(iter != NULL)
		iter = iter->prev;
            }
 
	    // Zugriff auf den Datenbereich
	    Monom2* returnData()
	    {   
	        return iter->data;  
	    }
	    
	    ListElement* returnElement() {
	    	return iter;
	    }
	};

public:	
	MyList();
	virtual ~MyList();
    ListElement* add(Monom2* data);
    bool isEmpty() { return (head == NULL) ? true : false; }
	void deleteElement(ListElement* element);
	void deleteList();
	void show();
	ListElement* begin();
	ListElement* end();
	ListElement* returnTail();	
	int getSize();

};

#endif /* MYLIST_H_ */
