/*
 * Polynom.h
 *
 *  Created on: 30.07.2018
 *      Author: Alexander Konrad
 */

#ifndef POLYNOM_H_
#define POLYNOM_H_

#include <stdlib.h>
#include <list>
#include <set>
#include <iostream>
#include "Monom2.h"

class Polynom {
friend class Verifizierer;
public:
	Polynom();  // Create empty polynom object.
	Polynom(int varSize);  // Create polynom object with refList of size varSize, which has an entry for every variable.
	//Polynom(Monom2 mon);  // Create polynom out of a monomial.
	Polynom(const Polynom& old);  // Copy constructor. 
	Polynom& operator=(const Polynom&);  // Assignment operator.
	virtual ~Polynom();
	bool addPolynom(const Polynom& other);  // Add polynom.
	void addMonom(Monom2 mon);  // Add a single monomial.
	void eraseMonom(Monom2 mon);  // Erase a monomial out ouf the polynom.
	void addRefVar(Monom2& mon, varIndex index, int i);  // Add pointer to refList of this variable and to the monom itself.
	void replaceAND(varIndex replace, varIndex in1, varIndex in2);  // Replace operation of AND gate.
	void replaceOR(varIndex replace, varIndex in1, varIndex in2);	// Replace operation of OR gate.
	void replaceXOR(varIndex replace, varIndex in1, varIndex in2);	// Replace operation of XOR gate.
	void replaceNOT(varIndex replace, varIndex in1);	// Replace operation of NOT gate.
	void replaceBUFFER(varIndex replace, varIndex in1);	// Replace operation of BUFFER gate.
	//void replaceCON0(varIndex replace);
	void replace(varIndex replace, std::list<Monom2> mons);  // General operation of replacing one variable in polynom with given list of monomials.
	const std::set<Monom2>* getSet() const;
	MyList* getRefList();
	size_t getVarSize();
	size_t size();
	void resize(size_t varSize);
	static Polynom multiplyPoly(Polynom& p1, Polynom& p2);  // Multiply two polynomials.
	friend std::ostream& operator<<(std::ostream& stdout, const Polynom& obj);
private:
	std::set<Monom2> polySet;
	MyList* refList;
	size_t varSize;

};

#endif /* POLYNOM_H_ */
